package eu.mhsl.craftattack.spawn.appliances.infoBars.bars;

import eu.mhsl.craftattack.spawn.Main;
import eu.mhsl.craftattack.spawn.appliances.infoBars.Bar;
import eu.mhsl.craftattack.spawn.appliances.playerlimit.PlayerLimit;
import eu.mhsl.craftattack.spawn.util.text.ColorUtil;
import net.kyori.adventure.bossbar.BossBar;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.TextColor;
import org.bukkit.Bukkit;

import java.time.Duration;

public class PlayerCounterBar extends Bar {
    @Override
    protected Duration refresh() {
        return Duration.ofSeconds(3);
    }

    @Override
    protected String name() {
        return "playerCounter";
    }

    @Override
    protected Component title() {
        TextColor color = ColorUtil.mapGreenToRed(this.getCurrentPlayerCount(), 0, this.getMaxPlayerCount(), true);
        return Component.text()
            .append(Component.text("Spieler online: "))
            .append(Component.text(this.getCurrentPlayerCount(), color))
            .build();
    }

    @Override
    protected float progress() {
        return (float) this.getCurrentPlayerCount() / this.getMaxPlayerCount();
    }

    @Override
    protected BossBar.Color color() {
        return BossBar.Color.BLUE;
    }

    @Override
    protected BossBar.Overlay overlay() {
        return BossBar.Overlay.PROGRESS;
    }

    private int getCurrentPlayerCount() {
        return Bukkit.getOnlinePlayers().size();
    }

    private int getMaxPlayerCount() {
        return Main.instance().getAppliance(PlayerLimit.class).getLimit();
    }
}
